### R code from vignette source 'Guide.Stex'

###################################################
### code chunk number 1: Guide.Stex:10-12
###################################################
 options(continue="  ")
 options(warn=1)


###################################################
### code chunk number 2: Guide.Stex:27-28
###################################################
library("TSodbc")  


###################################################
### code chunk number 3: Guide.Stex:47-52
###################################################
   user    <- Sys.getenv("ODBC_USER")
   if ("" != user) {
       passwd  <- Sys.getenv("ODBC_PASSWD")
       if ("" == passwd)   passwd <- NULL
      }


###################################################
### code chunk number 4: Guide.Stex:61-67
###################################################
m <- dbDriver("ODBC")
con <-  if ("" == user) odbcConnect(dsn="test") else
    odbcConnect(dsn="test", uid=user, pwd=passwd)
if(con == -1) stop("error establishing ODBC connection.") 
source(system.file("TSsql/CreateTables.TSsql", package = "TSdbi"))
odbcClose(channel=con)


###################################################
### code chunk number 5: Guide.Stex:84-87
###################################################
 m <- dbDriver("ODBC")
 con <-  if ("" == user) TSconnect(m, dbname="test") else
    TSconnect(m, dbname="test", uid=user, pwd=passwd)


###################################################
### code chunk number 6: Guide.Stex:96-101
###################################################
 z <- ts(rnorm(10), start=c(1990,1), frequency=1)
 seriesNames(z) <- "vec"
 if(TSexists("vec", con)) TSdelete("vec", con) 
 TSput( z, con)
 z <- TSget("vec", con)


###################################################
### code chunk number 7: Guide.Stex:115-123
###################################################
 z <- ts(matrix(rnorm(20),10,2), start=c(1990,1), frequency=1)
 seriesNames(z) <- c("matc1", "matc2")
 TSreplace(z, con)
 TSget("matc1", con)
 TSget("matc2", con)
 TSget(c("matc1","matc2"), con)
 tfplot(z+1, TSget(c("matc1","matc2"), con), 
          lty=c("solid", "dashed"), col=c("black", "red"))


###################################################
### code chunk number 8: Guide.Stex:126-132
###################################################
 z <- ts(matrix(rnorm(20),10,2), start=c(1990,1), frequency=4)
  seriesNames(z) <- c("matc1", "matc2")
 TSreplace(z, con)
 TSget(c("matc1","matc2"), con)
 tfplot(z+1, TSget(c("matc1","matc2"), con),
          lty=c("solid", "dashed"), col=c("black", "red"))


###################################################
### code chunk number 9: Guide.Stex:135-140
###################################################
 z <- ts(matrix(rnorm(200),100,2), start=c(1995,1), frequency=12)
  seriesNames(z) <- c("mat2c1", "mat2c2")
 TSreplace(z, con)
 tfplot(z+1, TSget(c("mat2c1","mat2c2"), con),
           lty=c("solid", "dashed"), col=c("black", "red"))


###################################################
### code chunk number 10: Guide.Stex:145-150
###################################################
 TSmeta("mat2c1", con)
 TSmeta("vec", con)
 TSdates("vec", con)
 TSdescription("vec", con)
 TSdoc("vec", con)


###################################################
### code chunk number 11: Guide.Stex:157-158
###################################################
 options(TSconnection=con)


###################################################
### code chunk number 12: Guide.Stex:164-166
###################################################
 z <- TSget("mat2c1") 
 TSmeta("mat2c1")


###################################################
### code chunk number 13: Guide.Stex:182-208
###################################################
 z <- ts(matrix(rnorm(10),10,1), start=c(1990,1), frequency=1)
 TSreplace(z, serIDs="Series1", con) 
 zz <- TSget("Series1", con)
 TSreplace(z, serIDs="Series1", con, 
     TSdescription="short rnorm series", 
     TSdoc="Series created as an example in the vignette.")
 zz <- TSget("Series1", con, TSdescription=TRUE, TSdoc=TRUE)
 start(zz)
 end(zz)
 TSdescription(zz)
 TSdoc(zz)

 TSdescription("Series1", con)
 TSdoc("Series1", con)

 z <- ts(rnorm(10), start=c(1990,1), frequency=1)
 seriesNames(z) <- "vec"
 TSreplace(z, con)
 zz <- TSget("vec", con)

 z <- ts(matrix(rnorm(20),10,2), start=c(1990,1), frequency=1)
 seriesNames(z) <- c("matc1", "matc2")
 TSreplace(z, con) 
 tfplot(z+1, TSget(c("matc1","matc2"), con),
           lty=c("solid", "dashed"), col=c("black", "red"))



###################################################
### code chunk number 14: Guide.Stex:211-217
###################################################
 z <- ts(matrix(rnorm(20),10,2), start=c(1990,1), frequency=4)
 seriesNames(z) <- c("matc1", "matc2")
 TSreplace(z, con)
 tfplot(z+1, TSget(c("matc1","matc2"), con),
           lty=c("solid", "dashed"), col=c("black", "red"))



###################################################
### code chunk number 15: Guide.Stex:220-225
###################################################
 z <- ts(matrix(rnorm(200),100,2), start=c(1995,1), frequency=12)
 seriesNames(z) <- c("mat2c1", "mat2c2")
 TSreplace(z, con) 
 tfplot(z+1, TSget(c("mat2c1","mat2c2"), con),
           lty=c("solid", "dashed"), col=c("black", "red"))


###################################################
### code chunk number 16: Guide.Stex:231-239
###################################################
require("zoo") 

 z <- zoo(matrix(rnorm(200),100,2), as.Date("1990-01-01") + 0:99)
  seriesNames(z) <- c("zooc1", "zooc2")
 TSreplace(z, con, Table="D")
 tfplot(z+1, TSget(c("zooc1","zooc2"), con),
           lty=c("solid", "dashed"), col=c("black", "red"))
  


###################################################
### code chunk number 17: Guide.Stex:242-247
###################################################
 z <- zoo(matrix(rnorm(200),100,2), as.Date("1990-01-01") + 0:99 * 7)
  seriesNames(z) <- c("zooWc1", "zooWc2")
 TSreplace(z, con, Table="W")
 tfplot(z+1, TSget(c("zooWc1","zooWc2"), con), col=c("black", "red"),
    lty=c("dashed", "solid"))  


###################################################
### code chunk number 18: Guide.Stex:250-252
###################################################
 dbDisconnect(con)
 #dbUnloadDriver(m)


###################################################
### code chunk number 19: Guide.Stex:266-268
###################################################
  con <-  if ("" == user) TSconnect("ODBC", dbname="test") else
    TSconnect("ODBC", dbname="test", uid=user, pwd=passwd)


###################################################
### code chunk number 20: Guide.Stex:273-283
###################################################
  require("TShistQuote")
  Yahoo <- TSconnect("histQuote", dbname="yahoo") 
  x <- TSget("^gspc", quote = "Close", con=Yahoo)
  plot(x)
  tfplot(x)

  TSrefperiod(x) 
  TSdescription(x) 
  TSdoc(x) 
  TSlabel(x) 


###################################################
### code chunk number 21: Guide.Stex:290-291
###################################################
   TSreplace(x,  serIDs="gspc", Table="B", con=con)


###################################################
### code chunk number 22: Guide.Stex:296-301
###################################################
  TSrefperiod(TSget(serIDs="gspc", con=con)) 
  TSdescription("gspc", con=con) 
  TSdoc("gspc", con=con)
  TSlabel("gspc", con=con) # this is not yet supported on the db
  tfplot(TSget(serIDs="gspc", con=con))


###################################################
### code chunk number 23: Guide.Stex:304-317
###################################################
   x <- TSget("ibm", quote = c("Close", "Vol"), con=Yahoo)
   TSreplace(x, serIDs=c("ibm.Cl", "ibm.Vol"),  con=con, Table="B",
              TSdescription.=c("IBM Close","IBM  Volume"),
	      TSdoc.= paste(c(
	         "IBM  Close   retrieved on ",
		 "IBM  Volume retrieved  on "), Sys.Date()))

   z <- TSget(serIDs=c("ibm.Cl", "ibm.Vol"), 
             TSdescription=TRUE, TSdoc=TRUE, con=con)
   TSdescription(z)
   TSdoc(z)
   tfplot(z, xlab = TSdoc(z), Title = TSdescription(z))
   tfplot(z, Title="IBM", start="2007-01-01")


###################################################
### code chunk number 24: Guide.Stex:323-326
###################################################
   Oanda <- TSconnect("histQuote", dbname="oanda") 
   x <- TSget("EUR/USD", start=Sys.Date() - 495, con=Oanda)
   TSreplace(x, serIDs="EUR/USD", Table="D", con=con)


###################################################
### code chunk number 25: Guide.Stex:331-337
###################################################
   z <- TSget(serIDs="EUR/USD",TSlabel=TRUE, TSdescription=TRUE,  con=con)
   tfplot(z, Title = TSdescription(z), ylab=TSlabel(z))
   tfplot(z, Title = "EUR/USD", start=Sys.Date() - 495)
   tfplot(z, Title = "EUR/USD", start=Sys.Date() - 100)
   tfplot(z, Title = "EUR/USD", start=Sys.Date()  -14, end=Sys.Date(),
      xlab = format(Sys.Date(), "%Y"))


###################################################
### code chunk number 26: Guide.Stex:340-343
###################################################
  dbDisconnect(con)
  dbDisconnect(Yahoo)
  dbDisconnect(Oanda)


###################################################
### code chunk number 27: Guide.Stex:362-389
###################################################
  m <- dbDriver("ODBC")
  conets <-  try(if ("" == user) TSconnect(m, dbname="ets") else
    TSconnect(m, dbname="ets", uid=user, pwd=passwd))
  if (!inherits(conets, "try-error")) {
  
  options(TSconnection=conets)

  print(TSmeta(TSget("M.SDR.CCUSMA02.ST")))

  EXCH.IDs <- t(matrix(c(
 	"M.SDR.CCUSMA02.ST",	 "SDR/USD exchange rate",
 	"M.CAN.CCUSMA02.ST",	 "CAN/USD exchange rate",
 	"M.MEX.CCUSMA02.ST",	 "MEX/USD exchange rate",
 	"M.JPN.CCUSMA02.ST",	 "JPN/USD exchange rate",
 	"M.EMU.CCUSMA02.ST",	 "Euro/USD exchange rate",
 	"M.OTO.CCUSMA02.ST",	 "OECD /USD exchange rate",
 	"M.G7M.CCUSMA02.ST",	 "G7   /USD exchange rate",
 	"M.E15.CCUSMA02.ST",	 "Euro 15. /USD exchange rate"
	), 2, 8))

  print(TSdates(EXCH.IDs[,1]))
  z <- TSdates(EXCH.IDs[,1])
  print(start(z))
  print(end(z))
   
  tfplot(TSget(serIDs="V122646", conets))
  }


###################################################
### code chunk number 28: Guide.Stex:392-401
###################################################
if (!inherits(conets, "try-error")) {
  print(TSdescription(TSget("V122646", TSdescription=TRUE)))
  print(TSdescription("V122646"))

  print(TSdoc(TSget("V122646", TSdoc=TRUE)))
  print(TSdoc("V122646"))

  tfplot(TSget("V122646", names="V122646", conets))
  }


###################################################
### code chunk number 29: Guide.Stex:404-408
###################################################
if (!inherits(conets, "try-error")) {
  z <- TSget("V122646", TSdescription=TRUE)
  tfplot(z, Title=strsplit(TSdescription(z), ","))
  }


###################################################
### code chunk number 30: Guide.Stex:411-416
###################################################
if (!inherits(conets, "try-error")) {
  z <- TSget("SDSP500", TSdescription=TRUE)
  tfplot(z, Title=TSdescription(z))
  plot(z)
  }


###################################################
### code chunk number 31: Guide.Stex:419-423
###################################################
if (!inherits(conets, "try-error")) {
  z <- TSget(c("DSP500","SDSP500"), TSdescription=TRUE)
  tfplot(z, xlab=TSdescription(z))
  }


###################################################
### code chunk number 32: Guide.Stex:426-429
###################################################
if (!inherits(conets, "try-error")) {
  plot(z)
  }


###################################################
### code chunk number 33: Guide.Stex:432-437
###################################################
if (!inherits(conets, "try-error")) {
  ETSgdp    <- annualizedGrowth(aggregate(TSget("V1992067"),
                   nfrequency=4,FUN=mean), lag=4, names="GDP Y/Y Growth")
  tfplot(ETSgdp)
  }  # end if !try-error


###################################################
### code chunk number 34: Guide.Stex:440-445
###################################################
  if (!inherits(conets, "try-error")) {
  #dbDisconnect(conets)
  dbDisconnect(options()$TSconnection)
  options(TSconnection=NULL)
  }  # end if try-error


###################################################
### code chunk number 35: Guide.Stex:456-460
###################################################
 m <- dbDriver("ODBC")
 con <-  if ("" == user) TSconnect(m, dbname="test") else
    TSconnect(m, dbname="test", uid=user, pwd=passwd)
 options(TSconnection=con)


###################################################
### code chunk number 36: Guide.Stex:464-465
###################################################
dbListTables(con)


###################################################
### code chunk number 37: Guide.Stex:475-488
###################################################
  tryCatch( dbGetQuery(con, paste(
       "SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.Columns ",
       " WHERE TABLE_SCHEMA='test' AND table_name='A' ;"))  )

  tryCatch( dbGetQuery(con, paste(
       "SELECT COLUMN_NAME, COLUMN_DEFAULT, COLLATION_NAME, DATA_TYPE,",
       "CHARACTER_SET_NAME, CHARACTER_MAXIMUM_LENGTH, NUMERIC_PRECISION",
 "FROM INFORMATION_SCHEMA.Columns WHERE TABLE_SCHEMA='test' AND table_name='A' ;"))  )

  tryCatch( dbGetQuery(con, paste(
   "SELECT COLUMN_NAME, DATA_TYPE, CHARACTER_MAXIMUM_LENGTH, NUMERIC_PRECISION",
 "FROM INFORMATION_SCHEMA.Columns WHERE TABLE_SCHEMA='test' AND table_name='M';"))  )



###################################################
### code chunk number 38: Guide.Stex:493-498
###################################################
  dbDisconnect(con)
  #dbDisconnect(options()$TSconnection)
  options(TSconnection=NULL)
  odbcCloseAll()
  dbUnloadDriver(m)


